//WinExit (C) Copyright 1995 by Savage Software
//							Written by Dominique Louis
#include <owl\owlpch.h>
#include <owl\applicat.h>
#include <owl\framewin.h>
#include <owl\menu.h>
#include "winexit.h"

class TWinExitWindow : public TFrameWindow
{
  public:
	 TWinExitWindow(TWindow *parent, char far *title):TFrameWindow(parent, title)
	 {

	 }
	 ~TWinExitWindow()
	 {

	 }
	 int EvCreate(CREATESTRUCT&);
	 BOOL EvQueryOpen();
	 void EvSysCommand(UINT, TPoint&);

	 // Override member function of TWindow
	 BOOL CanClose();
	 void CmWinExit();
	 void CmReboot();
	 void CmRestart();

	 protected:
    
	 private:
	 UINT CurSelect;
	 BOOL OnTop;


	 DECLARE_RESPONSE_TABLE(TWinExitWindow);
};

DEFINE_RESPONSE_TABLE1(TWinExitWindow, TFrameWindow)
	EV_WM_CREATE,
	EV_WM_QUERYOPEN,
	EV_WM_SYSCOMMAND,
END_RESPONSE_TABLE;

BOOL TWinExitWindow::CanClose()
{
	return TRUE;
}

BOOL TWinExitWindow::EvQueryOpen()
{
	if (CurSelect == CM_WINEXIT)
	{
		ExitWindows(0,0);
	}
	if (CurSelect == CM_REBOOT)
	{
		ExitWindows(EW_REBOOTSYSTEM,0);
	}
	if (CurSelect == CM_RESTART)
	{
		ExitWindows(EW_RESTARTWINDOWS,0);
	}
	return FALSE;
}

void TWinExitWindow::CmWinExit()
{
	CurSelect = CM_WINEXIT;
}

void TWinExitWindow::CmReboot()
{
	CurSelect = CM_REBOOT;
}

void TWinExitWindow::CmRestart()
{
	CurSelect = CM_RESTART;
}

void TWinExitWindow::EvSysCommand(UINT cmdType, TPoint &)
{
	TSystemMenu sysmenu(HWindow);
	switch (cmdType)
	{
		//Set Menu check flag to Quick Exit
		case CM_WINEXIT:
			CmWinExit();
			CheckMenuItem(sysmenu, CM_WINEXIT, MF_CHECKED);
			CheckMenuItem(sysmenu, CM_REBOOT, MF_UNCHECKED);
			CheckMenuItem(sysmenu, CM_RESTART, MF_UNCHECKED);
		break;
		//Set Menu check flag to Reboot System
		case CM_REBOOT:
			CmReboot();
			CheckMenuItem(sysmenu, CM_WINEXIT, MF_UNCHECKED);
			CheckMenuItem(sysmenu, CM_REBOOT, MF_CHECKED);
			CheckMenuItem(sysmenu, CM_RESTART, MF_UNCHECKED);
		break;
		//Set Menu check flag to Resart Computer
		case CM_RESTART:
			CmRestart();
			CheckMenuItem(sysmenu, CM_WINEXIT, MF_UNCHECKED);
			CheckMenuItem(sysmenu, CM_REBOOT, MF_UNCHECKED);
			CheckMenuItem(sysmenu, CM_RESTART, MF_CHECKED);
		break;
		// Set Menu Check to Stay On Top
		case CM_ONTOP:
		   OnTop = !OnTop;
			if(OnTop)
			{
				CheckMenuItem(sysmenu, CM_ONTOP, MF_CHECKED);
				//Make Icon Stay on Top
				SetWindowPos(HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
				UpdateWindow();
			}
			else
			{
			  CheckMenuItem(sysmenu, CM_ONTOP, MF_UNCHECKED);
			  // Make Icon behave Normally
			  SetWindowPos(HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
			  UpdateWindow();
			}
		break;
		default:
			DefaultProcessing();
	}
}

int TWinExitWindow::EvCreate(CREATESTRUCT& cs)
{
	TFrameWindow::EvCreate(cs);
	TSystemMenu sysmenu(HWindow);
	sysmenu.AppendMenu(MF_SEPARATOR, 0, (LPSTR)0);
	sysmenu.AppendMenu(MF_STRING, CM_WINEXIT, "&Quick Exit");
	CheckMenuItem(sysmenu, CM_WINEXIT, MF_CHECKED);
	CurSelect = CM_WINEXIT;
	sysmenu.AppendMenu(MF_STRING, CM_REBOOT, "Re&Boot System");
	sysmenu.AppendMenu(MF_STRING, CM_RESTART, "Re&Start Windows");
	sysmenu.AppendMenu(MF_SEPARATOR, 0, (LPSTR)0);
	sysmenu.AppendMenu(MF_STRING, CM_ONTOP, "Stay on &Top");
	CheckMenuItem(sysmenu, CM_ONTOP, MF_CHECKED);
	OnTop = TRUE;
	SetWindowPos(HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
	sysmenu.RemoveMenu(0, MF_BYPOSITION);
	sysmenu.RemoveMenu(1, MF_BYPOSITION);
	sysmenu.RemoveMenu(1, MF_BYPOSITION);
	sysmenu.RemoveMenu(1, MF_BYPOSITION);
	UpdateWindow();
	return 1;
}

class TWinExitApp : public TApplication {
  public:
	 TWinExitApp() : TApplication() {}

	 void InitMainWindow()
	 {
		MainWindow = new TWinExitWindow(0, "WinExit");
		MainWindow->SetIcon(this, 100);
		EnableCtl3d();
		nCmdShow = SW_SHOWMINIMIZED;
	 }
};


int OwlMain(int /*argc*/, char* /*argv*/ [])
{
	TWinExitApp WinExitApp;
	return WinExitApp.Run();
}